/*
        alph: Piper program implementing and analysing traditional and
        historic c(ai)phers designed to be used in conjuction with other
        programs.

        Copyright (C) 2004  Corcalciuc V. Horia

        This library is free software; you can redistribute it and/or
        modify it under the terms of the GNU Lesser General Public
        License as published by the Free Software Foundation; either
        version 2.1 of the License, or (at your option) any later version.

        This library is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
        Lesser General Public License for more details.

        You should have received a copy of the GNU Lesser General Public
        License along with this library; if not, write to the Free Software
        Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

*/

#include <sys/time.h>
#include <math.h>

#include "alphan.h"
#include "anstats.h"

alphize cystats(char *indata, char *key)
{
	unsigned int itra, itrb;
  struct timeval *en_start, *en_stop;
  struct timeval *de_start, *de_stop;
  alphize an;
  extern al_dec;
  
  an.sensitivity=0;
  an.consistency=0;
  
  en_start=calloc(1, sizeof(time_t));
	en_stop=calloc(1, sizeof(time_t));
	de_start=calloc(1, sizeof(time_t));
	de_stop=calloc(1, sizeof(time_t));

	an.p_len=strlen(indata);
	an.p_size=an.p_len*sizeof(char);


  /* sensitivity table. */

	for(itra=0; itra<strlen(indata); itra++)
		if(ispunct(indata[itra]))
			switch(indata[itra])
			{
				case '\n':
				case ':':
					an.sensitivity+=1;
					break;
				case ' ':
				case '\"':
				case '\'':
				case ',':
				case '.':
					an.sensitivity+=2;
					break;
				case '!':
				case '?':
					an.sensitivity+=3;
					break;
			};
		
	 /* endecrypt run. */
   
   an.encrypted=calloc(strlen(indata), sizeof(char));
   strcpy(an.encrypted, indata);
	 
	 al_dec=0;
	 gettimeofday(en_start, 0);
	 if(key)
	   caip(indata, key);
	 else
	   caip(indata);
   gettimeofday(en_stop, 0);
   an.t_encrypt = en_stop->tv_usec-en_start->tv_usec;

   an.encrypted=calloc(strlen(indata), sizeof(char));
   strcpy(an.encrypted, indata);
   
   an.c_len=strlen(indata);
   an.c_size=strlen(indata)*sizeof(char);
   
   al_dec=1;
   gettimeofday(de_start, 0);
   if(key)
    caip(indata, key);
   else
    caip(indata);
   gettimeofday(de_stop, 0);
   an.t_decrypt = de_stop->tv_usec-de_start->tv_usec;
   
   an.decrypted=calloc(strlen(indata), sizeof(char));
   strcpy(an.decrypted, indata);
   
   an.speed=(an.t_decrypt+an.t_encrypt)/2.0;

   /* consistency. */
   
   for(itra=0; itra<strlen(indata); itra++)
    if(indata[itra]==an.decrypted[itra])
      an.consistency++;

   an.consistency=100*an.consistency/strlen(indata);
   
   /* frequency. */
   
   for(itra=0; itra<26; itra++)
    an.a26[itra]=0;
   
   for(itra=0; itra<=strlen(an.encrypted); itra++)
     if(isalpha(indata[itra]))
      for(itrb=0; itrb<strlen(lclatin); itrb++)
        if(lclatin[itrb]==indata[itra])
          {
           an.a26[itrb]+=1;
           break;
          }
          
   for(itra=0, itrb=0; itra<=sizeof(an.a26); itra++)
    itrb+=an.a26[itra];
    
   an.armor=an.speed/(strlen(indata)^itrb+an.sensitivity);
        
   return an;

}

