/*
        alph: Piper program implementing and analysing traditional and
        historic c(ai)phers designed to be used in conjuction with other
        programs.

        Copyright (C) 2004  Corcalciuc V. Horia

        This library is free software; you can redistribute it and/or
        modify it under the terms of the GNU Lesser General Public
        License as published by the Free Software Foundation; either
        version 2.1 of the License, or (at your option) any later version.

        This library is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
        Lesser General Public License for more details.

        You should have received a copy of the GNU Lesser General Public
        License along with this library; if not, write to the Free Software
        Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

*/

/* the variable alphabet can be used
   to declare a constant array containing
   characters in an alphabet.
*/

typedef char alphabet;
typedef int frequency;

/* the structure alphan returns. */

typedef struct
{
    float armor;
    int p_size;
    int c_size;
    int p_len;
    int c_len;
    char *encrypted;
    char *decrypted;
    time_t t_encrypt;
    time_t t_decrypt;
    float speed;
    int consistency;
    int sensitivity;
    frequency a26[26];
} alphize;

/* used to point to a cypher. */
int (*caip)();

/* Function to analyse encrypted data
   stored in "indata" with an optional
   "key" depending on the nature of the
   cypher.
*/

alphize cystats(char *indata, char *key);

/* alphabet. l(ower)c(ase)latin. */

const alphabet lclatin[] = { 'a', 'b', 'c', 'd', 'e', 
                             'f', 'g', 'h', 'i', 'j', 
                             'k', 'l', 'm', 'n', 'o', 
                             'p', 'q', 'r', 's', 't', 
                             'u', 'v', 'w', 'x', 'y', 
                             'z' };


